// prove.c
# include "alfa.h"

static void provacrypt(), provestringhe(), sommaeprodotto();
static double f1(),f2(),f3();
static size_t posstr();
///////////////////////////////////////////

typedef struct {double x,y;} coppiac;

coppiac addc (coppiac *A, coppiac *B)
{coppiac c; c.x=A->x+B->x; c.y=A->y+B->y; return c;}

void aum (int x)
{*(&x)=*(&x)+1;}

void altreprove()
{int x; double *X;
provacrypt();
x=5; aum(x); printf("%d\n",x);
printf("%.4f %.4f\n",atan2(0,-1),atan2(-0.001,-1));}

void altreprovev()
{int k; char *a[]={"xv","xpaint","xterm","emacs"};
for (k=0;k<4;k++) if (fork()==0) execlp(a[k],a[k],0);}

void altreprovex ()
{char a[200]; int u=-17,v=3; int x=65;
sommaeprodotto(); provestringhe();
printf("%d\n",13&27);
printf("\n%d\n",u/v); printf("%d %c\n",x,x);}

void altreprovey()
{char a[100]="01234";
strcpy(a,"abc"); puts(a); // output: abc
strcpy(a,"012345"); puts(a); // output: 012345
strncpy(a,"abcde",3); puts(a); // output: abc345
strcpy(a,"012345"); puts(a); // output: 012345
strncpy(a,"abc",7); puts(a); // output: abc
strcpy(a,"012"); strcpy(a+4,"456789"); puts(a); // output: 012
strncpy(a,"abcdefg",5); puts(a); // output: abcde56789
strcpy(a,"abcde"); puts(a); // output: abcde
printf("%d\n",posstr("012301850182","018"));
printf("%d\n",strspn("0123456","2015")); // output: 3
printf("%d\n",strspn("0123456","xy")); // output: 0
printf("%d\n",strspn("012121","012")); // output: 6
printf("%d\n",strspn("0123456","04")); // output: 1
printf("%d\n",strcspn("0123456","2015")); // output: 0
printf("%d\n",strcspn("0123456","xy")); // output: 7
printf("%d\n",strcspn("012121","81")); // output: 1
printf("%d\n",strcspn("0123456","34")); // output: 3
}

size_t posstr (char *A, char *B)
{char *X;
X=strstr(A,B); if (X==0) return -1; return X-A;}

size_t pos (const char *A, int x)
{char *P;
P=strchr(A,x);
if (P==0) return -1; return P-A;}

size_t posr (const char *A, int x)
{char *P;
P=strrchr(A,x);
if (P==0) return -1; return P-A;}

int eliminacntrl (char *A, char *B)
{int k;
for (k=0;*A;A++)
if (isprint(*A)) *(B++)=*A; else k++;
return k;}

void binomiali()
{int n=20,k;
printf("\n"); for (k=0;k<=n;k++)
printf("bin(%d,%2d) = %-12.0f\n",n,k,bin(n,k));}

void concat (char *A, char *B, char *C)
{for (;*A;A++,C++) *C=*A; for (;*B;B++,C++) *C=*B; *C=0;}

void concatena()
{char a[200],b[200],c[200];
printf("Prima stringa: "); input(a,60);
printf("Seconda stringa: "); input(b,60);
concat(a,b,c); printf("%s\n",c);}

void eliminacaratteri ()
{char a[200],b[200],*X,*Y,*C;
printf("\nInserisci la parola: "); input(a,80);
printf("\nInserisci i caratteri da eliminare: "); input(b,40);
for (C=b;*C;C++) {for (X=Y=a;*X;X++)
if (*X!=*C) *(Y++)=*X; *Y=0;}
printf("\n%s\n",a);}

void fattoriali()
{int n;
for (n=0;n<=20;n++) printf("%2d! = %-12.0f\n",n,fattoriale(n));}

void fibonacci()
{int n;
for (n=0;n<=100;n++)
{printf("%3d  %-12.0f\n",n,fib4(n).x); if (n==20) n=79;}}

void invertiparola()
{char parola[200],inversa[200],*X,*Y;
for (;;) {printf("\nQuale parola vuoi invertire? ");
input(parola,60); if (us(parola,"")) break;
printf("La parola originale e' %s.\n",parola);
for (X=parola;*X;X++);
for (X--,Y=inversa;X>=parola;X--,Y++) *Y=*X; *Y=0;
for (Y=inversa;*Y;Y++) *Y=tolower(*Y);
printf("Invertita diventa %s.\n",inversa);}}

void leggilentamente()
{char *X,file[200],testo[4000],ancora[200];
printf("Nome del file: "); input(file,40);
if (caricafile(file,testo,3900)!=1) return;
for (;;) {printf("\n"); for (X=testo;*X;X++)
{printf("%c",*X); fflush(stdout); aspetta(0.07);}
printf("\nVuoi continuare? "); input(ancora,10);
if (!us(ancora,"si'")) goto fine; printf("\n");}
fine: return;}

void modificafile ()
{char testo[20000],nome[100],nomemod[100],*X;
printf("Nome del file: "); input(nome,40);
if (caricafile(nome,testo,19000)!=1) return;
for (X=testo;*X;X++) *X=toupper(*X);
sprintf(nomemod,"%s.mod",nome);
scrivifile(testo,nomemod);}

void moltiplicazione()
{int n; double x=2.75;
for (n=0;n<6;n++) printf("%f\n",mrussa(n,x));}

void potenze()
{int n; double x=1.3;
for (n=0;n<5;n++) printf("%f\n",potenza(x,n));}

void provaargvar()
{printf("%.2f\n",somma(5,3.0,2.0,1.0,4.0,8.0));
diversi(STRINGA,"\nI valori sono:\n",INT,30,INT,20,INT,50,
DOUBLE,7.33,STRINGA,"\nFirmato Rossi\n",FINE);}

void provacasuali()
{int k;
printf("%d\n",RAND_MAX);
for (k=0;k<10;k++) printf("%d %d %.3f\n",
dado(6),dado2(-4,20),casualereale(0.0,1.0,0.001));}

void provacronometro()
{int n; double t1,t2; time_t adesso;
t1=cronometro();
for (n=0;n<5000;n++) printf("%d %d %d\n",n,n+n,n*n); t2=cronometro();
aspetta(2.5);
printf("%.3f %.3f %.9f %ld\n",t1,t2,t2-t1,CLOCKS_PER_SEC);}

void provaenviron ()
{int k; char *X; extern char **environ;
for (k=0;;k++) {X=environ[k];
if (X==0) break; puts(X);
X=getenv("PATH"); if (X) puts(X);}}

void provafork()
{pid_t figlio; int k;
figlio=fork();
if (figlio>0) {printf("Sono il padre.\n");
printf("Il PID del figlio e' %d.\n",figlio);}
else if (figlio==0) printf("Sono il figlio.\n");
printf("Ciao.\n");
printf("%d %d\n",getpid(),getppid());}

void provamcd()
{char p[200],q[200]; int a,b;
printf("Inserisci a: "); input(p,40); a=atoi(p);
printf("Inserisci b: "); input(q,40); b=atoi(q);
printf("%d %d\n",mcd(a,b),mcdb(a,b));}

void provamediana()
{double a[]={4,3.5,6,9,8,2};
printf("%.2f\n",mediana(a,4)); printf("%.2f\n",mediana(a,5));}

void provaquicksort()
{double a[]={8,6,3,2,5,7,4,5,8,3,9,1,2,6,5,4,5,2,5,1}; int k;
double *Dati[20];
quicksortpernumeri(a,0,19,minore);
for (k=0;k<20;k++) printf("%.2f ",a[k]); printf("\n");
for (k=0;k<20;k++) Dati[k]=a+k; Dati[20]=0;
quicksort(Dati,minoreperpuntatori);
for (k=0;k<20;k++) printf("%.2f ",*Dati[k]); printf("\n");}

void provastatic()
{static int s=0,k;
for (k=0;k<5;k++) s+=k; printf("%d\n",s);}

void provastirling()
{int n,k;
for (k=0;k<=10;k++) {printf("%d: ",k); for (n=0;n<=10;n++)
printf("%.0f ",stirling2(n,k)); printf("\n");}
printf("\nS(20,5) = %.0f\nS(50,4) = %.0f\n",stirling2(20,5),stirling2(50,4));}

char *strtoknostro (char *A, const char *L)
{char *E,*Q; static char *P=0;
E= A ? A: P? P:0; if (E==0) {P=0; return 0;}
E+=strspn(E,L); if (*E==0) {P=0; return 0;}
Q=strpbrk(E,L); if (Q) {*Q=0; P=Q+1;} else P=0; return E;}

void provastrtok()
{char a[100],*A;
strcpy(a,",alfa, beta,  , gamma    delta  ,  epsilon,");
for (A=a;;A=0) {A=strtoknostro(A," ,"); if (A==0) break; puts(A);}
strcpy(a,"alfa + beta, gamma+, +delta,  +7");
A=strtoknostro(a,"+ "); puts(A);
for (;;) {A=strtoknostro(0," ,"); if (A==0) break; puts(A);}}

void provawait()
{pid_t figlio; int k;
figlio=fork();
if (figlio>0) {printf("Sono il padre.\n");
printf("Il PID del figlio e' %d.\n",figlio); wait(0);}
else if (figlio==0) {printf("Sono il figlio.\n"); exit(0);}
printf("Ciao.\n");
printf("%d %d\n",getpid(),getppid());}

void provazeri()
{double a,b;
zero(f1,1.0,2.0,0.00000001,&a,&b);
// punto decimale necessario (pag. 64)
printf("radice quadrata di 2: %.8f < x < %.8f\n",a,b);
zero(f2,1.0,2.0,0.00000001,&a,&b);
printf("radice cubica a di 2: %.8f < x < %.8f\n",a,b);
zero(f3,1.5,3.0,0.00000001,&a,&b);
printf("zero di x^4-13x^3+56x^2-92x+48: %.8f < x < %.8f\n",a,b);}
//////////////////////////////////////////
static void provacrypt()
{printf("%s\n",crypt("toroseduto","Bk"));}

static void provestringhe()
{printf("%d %d %d\n",uis("alfa","alfa"),uis("alfa","alfabeto"),
uis("alfa","beta"));}

static void sommaeprodotto()
{int a[]={4,1,2,3,5,8,7,2}; int k,s,p; long long m;
for (s=0,k=0;k<8;k++) s+=a[k];
for (p=1,k=0;k<8;k++) p*=a[k];
printf("somma = %d\nprodotto = %d\n",s,p);}
//////////////////////////////////////////
static double f1 (double x)
{return x*x-2;}

static double f2 (double x)
{return x*x*x-2;}

static double f3 (double x)
{return x*x*x*x-13*x*x*x+56*x*x-92*x+48;}

