// tre-colori.c
# include "alfa.h"

enum {A,B,C,D,E,F,G,H};

typedef struct {int colori[8]; int rendimento;} partizione;

static void calcolarendimenti(), impostapuntatori(), incroci(),
  mutazioni(), nuovi(), ordina();
static int migliore(), visualizza();
static int g();

static int vicini[][2]={{A,B},{A,F},{A,H},{B,C},{B,D},{B,F},
  {C,D},{D,E},{D,F},{E,F},{E,G},{F,G},{F,H},{G,H},{-1,-1}};
static char *nomivertici[8]={"A","B","C","D","E","F","G","H"};
static partizione partizioni[40],*Puntatori[41];
//////////////////////////////////////////////
void trecolori ()
{int t,dt=1,ancora;
impostacasuali(); impostapuntatori(); nuovi(0,39);
for (t=1,ancora=1;ancora;t++) {calcolarendimenti(); ordina();
if (t%dt==0) ancora=visualizza(t);
nuovi(30,39); incroci(); mutazioni();}}

/////////////////////////////////////////////
static void calcolarendimenti()
{int k;
for (k=0;k<40;k++) Puntatori[k]->rendimento=g(Puntatori[k]);}

static void impostapuntatori()
{int k;
for (k=0;k<40;k++) Puntatori[k]=&partizioni[k]; Puntatori[k]=0;}

static void incroci()
{int k,i,c; partizione p,q,*P,*Q;
for (k=0;k<38;k+=2) {P=Puntatori[k]; p=*P; Q=Puntatori[k+1]; q=*Q;
for (i=0;i<8;i++) if (dado(2)==1)
{c=p.colori[i]; p.colori[i]=q.colori[i]; q.colori[i]=c;}
p.rendimento=g(&p); q.rendimento=g(&q);
if ((migliore(&p,P)&&migliore(&p,Q))||(migliore(&q,P)&&migliore(&q,Q)))
{*P=p; *Q=q;}}}

static void mutazioni()
{int k,i; partizione p,*P;
for (k=0;k<40;k++) {P=Puntatori[k]; p=*P;
for (i=0;i<8;i++) if (dado(8)==1) p.colori[i]=dado(3)-1;
p.rendimento=g(&p); if (migliore(&p,P)) *P=p;}}

static void nuovi (int a, int b)
{int k,i;
for (k=a;k<=b;k++) for (i=0;i<8;i++)
Puntatori[k]->colori[i]=dado(3)-1;}

static void ordina()
{quicksort(Puntatori,migliore);}

static int migliore (partizione *A, partizione *B)
{return (A->rendimento<B->rendimento);}

static int visualizza (int t)
{char a[100]; partizione *P=Puntatori[0]; int i;
printf("\nGenerazione %d, Rendimento %d:\n",t,P->rendimento);
for (i=0;i<8;i++) printf("\n%s %d",nomivertici[i],P->colori[i]);
printf("\n\nVuoi continuare? "); input(a,40);
if (us(a,"no")) return 0; return 1;}

static int g (partizione *P)
{int k,errori,a,b;
for (k=0,errori=0;;k++) {a=vicini[k][0]; b=vicini[k][1]; if (a==-1) break;
errori+=(P->colori[a]==P->colori[b]);} return errori;}
