// bezier.c
# include "alfa.h"

# define epsilon 0.5

static void casteljau();
////////////////////////////////////////////////////////////////
void provabezier()
{char a[400]; double x0,y0,x1,y1,x2,y2,x3,y3;
x0=-35; y0=0; x1=-20; y1=20; x2=24; y2=36; x3=35; y3=0;
sprintf(a,"2.83 2.83 scale 100 142 translate 0.1 setlinewidth\n"
"%.3f %.3f %.3f %.3f rectfill\n%.3f %.3f %.3f %.3f rectfill\n",
x0-epsilon/2,y0-epsilon/2,epsilon,epsilon,x3,y3,epsilon,epsilon);
scrivifile(a,"casteljau.ps"); casteljau(x0,y0,x1,y1,x2,y2,x3,y3);
aggiungifile("showpage","casteljau.ps");}

/////////////////////////////////////////////////////////////////
static void casteljau (double x0, double y0, double x1, double y1,
  double x2, double y2, double x3, double y3)
{char a[400]; double x01,y01,x12,y12,x23,y23,x02,y02,x13,y13,x03,y03;
if (fabs(x0-x3)+fabs(y0-y3)<epsilon) return;
x01=(x0+x1)/2; y01=(y0+y1)/2; x12=(x1+x2)/2; y12=(y1+y2)/2;
x23=(x2+x3)/2; y23=(y2+y3)/2; x02=(x01+x12)/2; y02=(y01+y12)/2;
x13=(x12+x23)/2; y13=(y12+y23)/2; x03=(x02+x13)/2; y03=(y02+y13)/2;
sprintf(a,"%.3f %.3f %.3f %.3f rectfill\n",x03-epsilon/2,
  y03-epsilon/2,epsilon,epsilon);
aggiungifile(a,"casteljau.ps");
casteljau(x0,y0,x01,y01,x02,y02,x03,y03);
casteljau(x03,y03,x13,y13,x23,y23,x3,y3);}

