// quicksort.c
# include "alfa.h"

static void quicksortinterno ();
////////////////////////////////////////////////////////////////////////
void quicksort (void **Dati, int (*migliore)())
{int n; void **Ultimo;
for (Ultimo=Dati,n=0;*Ultimo;Ultimo++,n++);
quicksortinterno(Dati,0,n-1,migliore);}

void quicksortpernumeri (double *A, int sin, int des, int (*migliore)())
{double conf,x; int p,i,m;
if (sin>=des) return; m=(sin+des)/2;
conf=A[m]; A[m]=A[sin]; p=sin+1; for (i=p;i<=des;i++)
if ((*migliore)(A[i],conf)) {x=A[p]; A[p]=A[i]; A[i]=x; p++;}
p--; A[sin]=A[p]; A[p]=conf;
quicksortpernumeri(A,sin,p-1,migliore);
quicksortpernumeri(A,p+1,des,migliore);}

int minore (double a, double b)
{return (a<b);}

int minoreperpuntatori (double *A, double *B)
{return (*A<*B);}
//////////////////////////////////////////////////////////////////////////
static void quicksortinterno (void **Dati, int sin, int des, int (*migliore)())
{void *Conf,*X; int p,i,m;
if (sin>=des) return; m=(sin+des)/2;
Conf=Dati[m]; Dati[m]=Dati[sin]; p=sin+1;
for (i=p;i<=des;i++) if ((*migliore)(Dati[i],Conf))
{X=Dati[p]; Dati[p]=Dati[i]; Dati[i]=X; p++;}
p--; Dati[sin]=Dati[p]; Dati[p]=Conf;
quicksortinterno(Dati,sin,p-1,migliore);
quicksortinterno(Dati,p+1,des,migliore);}

